from django.contrib import admin

from django_stockfin_db.models import FinancialPosition, ReportingPeriod, Company, CompanyName, Figure


@admin.register(FinancialPosition)
class FinancialPositionAdmin(admin.ModelAdmin):
    list_display = ('name', 'financial_statement', 'parent_name')

    @admin.display(description='Parent Position Name')
    def parent_name(self, obj: FinancialPosition) -> str:
        return obj.parent.name if obj.parent else '-'


@admin.register(ReportingPeriod)
class ReportingPeriodAdmin(admin.ModelAdmin):
    list_display = ('__str__', 'date_end', 'date_start')


@admin.register(Company)
class CompanyAdmin(admin.ModelAdmin):
    list_display = ('__str__', 'symbol')


@admin.register(CompanyName)
class CompanyNameAdmin(admin.ModelAdmin):
    pass


@admin.register(Figure)
class FigureAdmin(admin.ModelAdmin):
    list_display = ('position', 'period', 'company', 'value')
